diff --git a/kc.c b/kc.c
index 0a8de3b..27a3fb9 100644
--- a/kc.c
+++ b/kc.c
@@ -66,7 +66,7 @@ I wds_(K*a,FILE*f,I l)
 I lines(FILE*f) {S a=0;I n=0;PDA p=0; while(-1!=line(f,&a,&n,&p));R 0;}//You could put lines(stdin) in main() to have not-multiplexed command-line-only input
 I line(FILE*f, S*a, I*n, PDA*p) // just starting or just executed: *a=*n=*p=0,  intermediate is non-zero
 {
-  S s=0; I b=0,c=0,m=0; fef=0;
+  S s=0; I b=0,c=0,m=0;
   K k; F d;
 
   //I o = isatty(STDIN) && f==stdin; //display results to stdout?
diff --git a/kc.h b/kc.h
index 283382f..7c055cf 100644
--- a/kc.h
+++ b/kc.h
@@ -54,4 +54,3 @@ I prompt(I n);
 extern I adverb_ct;
 extern I vn_ct,vm_ct,vd_ct,vt_ct;
 extern I interrupted;
-extern I fef;
diff --git a/kx.c b/kx.c
index 60a69cb..3fe3bfa 100644
--- a/kx.c
+++ b/kx.c
@@ -497,25 +497,21 @@ K vf_ex(V q, K g)
     )
   }
 
-cleanup:
-
-  if(z && !fef){
-    if(z->t==7 && z->n==3 && kV(z)[CODE] && strchr(kC(kK(z)[CODE]),"x"[0]) && kV(z)[PARAMS] && kK(z)[PARAMS]->n){
-      fef=1;
-      DO(kK(z)[PARAMS]->n, if(!strcmp(*kS(kK(kK(kK(z)[PARAMS])[i])[0]),"x")){fef=0; break;} )
+  I ff=0;
+  if(z && z->t==7 && z->n==3 && kV(z)[CODE] && strchr(kC(kK(z)[CODE]),"x"[0]) && kV(z)[PARAMS] && kK(z)[PARAMS]->n){
+    ff=1; DO(kK(z)[PARAMS]->n, if(!strcmp(*kS(kK(kK(kK(z)[PARAMS])[i])[0]),"x")){ff=0; break;} )
+  }  
+  if(ff){
+    K d=kK(kK(KTREE)[0])[1]; K x=0;
+    DO(d->n, if(!strcmp(*kS(kK(kK(d)[i])[0]),"x")){x=kclone(kK(d)[i]); break;})
+    if(x){
+      K p=kK(g)[0]; cd(kK(x)[1]); kK(x)[1]=kclone(p);
+      K xe=enlist(x); K x2=dot_monadic(xe);
+      cd(kK(z)[LOCALS]); kK(z)[LOCALS]=x2; cd(x); cd(xe);
     }
-
-    if(fef){
-      K d=kK(kK(KTREE)[0])[1]; K x=0;
-      DO(d->n, if(!strcmp(*kS(kK(kK(d)[i])[0]),"x")){x=kclone(kK(d)[i]); break;})
-      if(x){
-        K p=kK(g)[0]; cd(kK(x)[1]); kK(x)[1]=kclone(p);
-        K xe=enlist(x); K x2=dot_monadic(xe);
-        cd(kK(z)[LOCALS]); kK(z)[LOCALS]=x2; cd(x); cd(xe);
-      } else fef=0;
-    } else fef=0;
   }
 
+cleanup:
   cd(g);
   R z;
 }
diff --git a/p.c b/p.c
index 6fef2ee..db4d62b 100644
--- a/p.c
+++ b/p.c
@@ -221,7 +221,12 @@ K wd_(S s, I n, K*dict, K func) //parse: s input string, n length ; assumes: s d
 {
   if(!s) R 0;
 
-  if(fef && func && kV(func)[LOCALS] && kK(func)[LOCALS]->n){fef=0;
+  I ff=0;
+  if(func && kV(func)[LOCALS] && kK(func)[LOCALS]->n){
+    DO(kK(func)[LOCALS]->n, if(!strcmp(*kS(kK(kK(kK(func)[LOCALS])[i])[0]),"x")){ff=1; break;} ) 
+    DO((*dict)->n, if(!strcmp(*kS(kK(kK(*dict)[i])[0]),"x")){ff=0; break;})
+  } 
+  if(ff){
     K j0=dot_monadic(*dict); K j1=dot_monadic(kK(func)[LOCALS]); K j2=join(j0,j1);
     cd(*dict); *dict=dot_monadic(j2); cd(j0); cd(j1); cd(j2);  
   }
diff --git a/p.h b/p.h
index f98aeef..a23912b 100644
--- a/p.h
+++ b/p.h
@@ -59,4 +59,3 @@ extern S right;
 extern S left;
 extern S formed_dfa;
 I charpos(S s,C c);
-extern I fef;
diff --git a/tests.c b/tests.c
index 659d44c..d2f0c24 100644
--- a/tests.c
+++ b/tests.c
@@ -35,8 +35,8 @@ I tc(S a, S b) //test comparison .  R 0,1,2
   kreci=0;
 
   KTREE=Kd();
-  fef=0; K x = X(a);
-  fef=0; K y = X(b);
+  K x = X(a);
+  K y = X(b);
   I m=matchI(x,y);
 
   if(!m)
diff --git a/tests.h b/tests.h
index 110996b..0bcae0c 100644
--- a/tests.h
+++ b/tests.h
@@ -28,4 +28,3 @@ extern I test_print;
 I tc(S a,S b);
 I tp(I x);
 S ts(I x);
-extern I fef;
